declare namespace java {
    namespace awt {
        namespace PageAttributes {
            /**
             * A type-safe enumeration of possible paper sizes. These sizes are in
             * compliance with IPP 1.1.
             * @since 1.3
             */
            // @ts-ignore
            class MediaType extends java.awt.AttributeValue {
                /**
                 * The MediaType instance for ISO/DIN and JIS 4A0, 1682 x 2378 mm.
                 */
                // @ts-ignore
                public static readonly ISO_4A0: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN and JIS 2A0, 1189 x 1682 mm.
                 */
                // @ts-ignore
                public static readonly ISO_2A0: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN and JIS A0, 841 x 1189 mm.
                 */
                // @ts-ignore
                public static readonly ISO_A0: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN and JIS A1, 594 x 841 mm.
                 */
                // @ts-ignore
                public static readonly ISO_A1: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN and JIS A2, 420 x 594 mm.
                 */
                // @ts-ignore
                public static readonly ISO_A2: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN and JIS A3, 297 x 420 mm.
                 */
                // @ts-ignore
                public static readonly ISO_A3: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN and JIS A4, 210 x 297 mm.
                 */
                // @ts-ignore
                public static readonly ISO_A4: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN and JIS A5, 148 x 210 mm.
                 */
                // @ts-ignore
                public static readonly ISO_A5: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN and JIS A6, 105 x 148 mm.
                 */
                // @ts-ignore
                public static readonly ISO_A6: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN and JIS A7, 74 x 105 mm.
                 */
                // @ts-ignore
                public static readonly ISO_A7: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN and JIS A8, 52 x 74 mm.
                 */
                // @ts-ignore
                public static readonly ISO_A8: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN and JIS A9, 37 x 52 mm.
                 */
                // @ts-ignore
                public static readonly ISO_A9: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN and JIS A10, 26 x 37 mm.
                 */
                // @ts-ignore
                public static readonly ISO_A10: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN B0, 1000 x 1414 mm.
                 */
                // @ts-ignore
                public static readonly ISO_B0: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN B1, 707 x 1000 mm.
                 */
                // @ts-ignore
                public static readonly ISO_B1: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN B2, 500 x 707 mm.
                 */
                // @ts-ignore
                public static readonly ISO_B2: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN B3, 353 x 500 mm.
                 */
                // @ts-ignore
                public static readonly ISO_B3: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN B4, 250 x 353 mm.
                 */
                // @ts-ignore
                public static readonly ISO_B4: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN B5, 176 x 250 mm.
                 */
                // @ts-ignore
                public static readonly ISO_B5: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN B6, 125 x 176 mm.
                 */
                // @ts-ignore
                public static readonly ISO_B6: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN B7, 88 x 125 mm.
                 */
                // @ts-ignore
                public static readonly ISO_B7: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN B8, 62 x 88 mm.
                 */
                // @ts-ignore
                public static readonly ISO_B8: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN B9, 44 x 62 mm.
                 */
                // @ts-ignore
                public static readonly ISO_B9: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN B10, 31 x 44 mm.
                 */
                // @ts-ignore
                public static readonly ISO_B10: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for JIS B0, 1030 x 1456 mm.
                 */
                // @ts-ignore
                public static readonly JIS_B0: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for JIS B1, 728 x 1030 mm.
                 */
                // @ts-ignore
                public static readonly JIS_B1: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for JIS B2, 515 x 728 mm.
                 */
                // @ts-ignore
                public static readonly JIS_B2: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for JIS B3, 364 x 515 mm.
                 */
                // @ts-ignore
                public static readonly JIS_B3: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for JIS B4, 257 x 364 mm.
                 */
                // @ts-ignore
                public static readonly JIS_B4: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for JIS B5, 182 x 257 mm.
                 */
                // @ts-ignore
                public static readonly JIS_B5: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for JIS B6, 128 x 182 mm.
                 */
                // @ts-ignore
                public static readonly JIS_B6: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for JIS B7, 91 x 128 mm.
                 */
                // @ts-ignore
                public static readonly JIS_B7: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for JIS B8, 64 x 91 mm.
                 */
                // @ts-ignore
                public static readonly JIS_B8: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for JIS B9, 45 x 64 mm.
                 */
                // @ts-ignore
                public static readonly JIS_B9: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for JIS B10, 32 x 45 mm.
                 */
                // @ts-ignore
                public static readonly JIS_B10: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN C0, 917 x 1297 mm.
                 */
                // @ts-ignore
                public static readonly ISO_C0: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN C1, 648 x 917 mm.
                 */
                // @ts-ignore
                public static readonly ISO_C1: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN C2, 458 x 648 mm.
                 */
                // @ts-ignore
                public static readonly ISO_C2: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN C3, 324 x 458 mm.
                 */
                // @ts-ignore
                public static readonly ISO_C3: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN C4, 229 x 324 mm.
                 */
                // @ts-ignore
                public static readonly ISO_C4: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN C5, 162 x 229 mm.
                 */
                // @ts-ignore
                public static readonly ISO_C5: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN C6, 114 x 162 mm.
                 */
                // @ts-ignore
                public static readonly ISO_C6: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN C7, 81 x 114 mm.
                 */
                // @ts-ignore
                public static readonly ISO_C7: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN C8, 57 x 81 mm.
                 */
                // @ts-ignore
                public static readonly ISO_C8: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN C9, 40 x 57 mm.
                 */
                // @ts-ignore
                public static readonly ISO_C9: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO/DIN C10, 28 x 40 mm.
                 */
                // @ts-ignore
                public static readonly ISO_C10: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for ISO Designated Long, 110 x 220 mm.
                 */
                // @ts-ignore
                public static readonly ISO_DESIGNATED_LONG: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for Executive, 7 1/4 x 10 1/2 in.
                 */
                // @ts-ignore
                public static readonly EXECUTIVE: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for Folio, 8 1/2 x 13 in.
                 */
                // @ts-ignore
                public static readonly FOLIO: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for Invoice, 5 1/2 x 8 1/2 in.
                 */
                // @ts-ignore
                public static readonly INVOICE: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for Ledger, 11 x 17 in.
                 */
                // @ts-ignore
                public static readonly LEDGER: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for North American Letter, 8 1/2 x 11 in.
                 */
                // @ts-ignore
                public static readonly NA_LETTER: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for North American Legal, 8 1/2 x 14 in.
                 */
                // @ts-ignore
                public static readonly NA_LEGAL: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for Quarto, 215 x 275 mm.
                 */
                // @ts-ignore
                public static readonly QUARTO: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for Engineering A, 8 1/2 x 11 in.
                 */
                // @ts-ignore
                public static readonly A: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for Engineering B, 11 x 17 in.
                 */
                // @ts-ignore
                public static readonly B: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for Engineering C, 17 x 22 in.
                 */
                // @ts-ignore
                public static readonly C: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for Engineering D, 22 x 34 in.
                 */
                // @ts-ignore
                public static readonly D: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for Engineering E, 34 x 44 in.
                 */
                // @ts-ignore
                public static readonly E: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for North American 10 x 15 in.
                 */
                // @ts-ignore
                public static readonly NA_10X15_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for North American 10 x 14 in.
                 */
                // @ts-ignore
                public static readonly NA_10X14_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for North American 10 x 13 in.
                 */
                // @ts-ignore
                public static readonly NA_10X13_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for North American 9 x 12 in.
                 */
                // @ts-ignore
                public static readonly NA_9X12_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for North American 9 x 11 in.
                 */
                // @ts-ignore
                public static readonly NA_9X11_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for North American 7 x 9 in.
                 */
                // @ts-ignore
                public static readonly NA_7X9_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for North American 6 x 9 in.
                 */
                // @ts-ignore
                public static readonly NA_6X9_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for North American #9 Business Envelope,
                 * 3 7/8 x 8 7/8 in.
                 */
                // @ts-ignore
                public static readonly NA_NUMBER_9_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for North American #10 Business Envelope,
                 * 4 1/8 x 9 1/2 in.
                 */
                // @ts-ignore
                public static readonly NA_NUMBER_10_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for North American #11 Business Envelope,
                 * 4 1/2 x 10 3/8 in.
                 */
                // @ts-ignore
                public static readonly NA_NUMBER_11_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for North American #12 Business Envelope,
                 * 4 3/4 x 11 in.
                 */
                // @ts-ignore
                public static readonly NA_NUMBER_12_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for North American #14 Business Envelope,
                 * 5 x 11 1/2 in.
                 */
                // @ts-ignore
                public static readonly NA_NUMBER_14_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for Invitation Envelope, 220 x 220 mm.
                 */
                // @ts-ignore
                public static readonly INVITE_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for Italy Envelope, 110 x 230 mm.
                 */
                // @ts-ignore
                public static readonly ITALY_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for Monarch Envelope, 3 7/8 x 7 1/2 in.
                 */
                // @ts-ignore
                public static readonly MONARCH_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * The MediaType instance for 6 3/4 envelope, 3 5/8 x 6 1/2 in.
                 */
                // @ts-ignore
                public static readonly PERSONAL_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_A0.
                 */
                // @ts-ignore
                public static readonly A0: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_A1.
                 */
                // @ts-ignore
                public static readonly A1: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_A2.
                 */
                // @ts-ignore
                public static readonly A2: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_A3.
                 */
                // @ts-ignore
                public static readonly A3: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_A4.
                 */
                // @ts-ignore
                public static readonly A4: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_A5.
                 */
                // @ts-ignore
                public static readonly A5: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_A6.
                 */
                // @ts-ignore
                public static readonly A6: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_A7.
                 */
                // @ts-ignore
                public static readonly A7: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_A8.
                 */
                // @ts-ignore
                public static readonly A8: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_A9.
                 */
                // @ts-ignore
                public static readonly A9: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_A10.
                 */
                // @ts-ignore
                public static readonly A10: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_B0.
                 */
                // @ts-ignore
                public static readonly B0: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_B1.
                 */
                // @ts-ignore
                public static readonly B1: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_B2.
                 */
                // @ts-ignore
                public static readonly B2: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_B3.
                 */
                // @ts-ignore
                public static readonly B3: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_B4.
                 */
                // @ts-ignore
                public static readonly B4: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_B4.
                 */
                // @ts-ignore
                public static readonly ISO_B4_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_B5.
                 */
                // @ts-ignore
                public static readonly B5: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_B5.
                 */
                // @ts-ignore
                public static readonly ISO_B5_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_B6.
                 */
                // @ts-ignore
                public static readonly B6: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_B7.
                 */
                // @ts-ignore
                public static readonly B7: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_B8.
                 */
                // @ts-ignore
                public static readonly B8: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_B9.
                 */
                // @ts-ignore
                public static readonly B9: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_B10.
                 */
                // @ts-ignore
                public static readonly B10: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C0.
                 */
                // @ts-ignore
                public static readonly C0: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C0.
                 */
                // @ts-ignore
                public static readonly ISO_C0_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C1.
                 */
                // @ts-ignore
                public static readonly C1: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C1.
                 */
                // @ts-ignore
                public static readonly ISO_C1_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C2.
                 */
                // @ts-ignore
                public static readonly C2: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C2.
                 */
                // @ts-ignore
                public static readonly ISO_C2_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C3.
                 */
                // @ts-ignore
                public static readonly C3: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C3.
                 */
                // @ts-ignore
                public static readonly ISO_C3_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C4.
                 */
                // @ts-ignore
                public static readonly C4: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C4.
                 */
                // @ts-ignore
                public static readonly ISO_C4_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C5.
                 */
                // @ts-ignore
                public static readonly C5: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C5.
                 */
                // @ts-ignore
                public static readonly ISO_C5_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C6.
                 */
                // @ts-ignore
                public static readonly C6: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C6.
                 */
                // @ts-ignore
                public static readonly ISO_C6_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C7.
                 */
                // @ts-ignore
                public static readonly C7: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C7.
                 */
                // @ts-ignore
                public static readonly ISO_C7_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C8.
                 */
                // @ts-ignore
                public static readonly C8: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C8.
                 */
                // @ts-ignore
                public static readonly ISO_C8_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C9.
                 */
                // @ts-ignore
                public static readonly C9: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C9.
                 */
                // @ts-ignore
                public static readonly ISO_C9_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C10.
                 */
                // @ts-ignore
                public static readonly C10: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_C10.
                 */
                // @ts-ignore
                public static readonly ISO_C10_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ISO_DESIGNATED_LONG.
                 */
                // @ts-ignore
                public static readonly ISO_DESIGNATED_LONG_ENVELOPE: java.awt.PageAttributes.MediaType
                /**
                 * An alias for INVOICE.
                 */
                // @ts-ignore
                public static readonly STATEMENT: java.awt.PageAttributes.MediaType
                /**
                 * An alias for LEDGER.
                 */
                // @ts-ignore
                public static readonly TABLOID: java.awt.PageAttributes.MediaType
                /**
                 * An alias for NA_LETTER.
                 */
                // @ts-ignore
                public static readonly LETTER: java.awt.PageAttributes.MediaType
                /**
                 * An alias for NA_LETTER.
                 */
                // @ts-ignore
                public static readonly NOTE: java.awt.PageAttributes.MediaType
                /**
                 * An alias for NA_LEGAL.
                 */
                // @ts-ignore
                public static readonly LEGAL: java.awt.PageAttributes.MediaType
                /**
                 * An alias for NA_10X15_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly ENV_10X15: java.awt.PageAttributes.MediaType
                /**
                 * An alias for NA_10X14_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly ENV_10X14: java.awt.PageAttributes.MediaType
                /**
                 * An alias for NA_10X13_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly ENV_10X13: java.awt.PageAttributes.MediaType
                /**
                 * An alias for NA_9X12_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly ENV_9X12: java.awt.PageAttributes.MediaType
                /**
                 * An alias for NA_9X11_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly ENV_9X11: java.awt.PageAttributes.MediaType
                /**
                 * An alias for NA_7X9_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly ENV_7X9: java.awt.PageAttributes.MediaType
                /**
                 * An alias for NA_6X9_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly ENV_6X9: java.awt.PageAttributes.MediaType
                /**
                 * An alias for NA_NUMBER_9_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly ENV_9: java.awt.PageAttributes.MediaType
                /**
                 * An alias for NA_NUMBER_10_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly ENV_10: java.awt.PageAttributes.MediaType
                /**
                 * An alias for NA_NUMBER_11_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly ENV_11: java.awt.PageAttributes.MediaType
                /**
                 * An alias for NA_NUMBER_12_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly ENV_12: java.awt.PageAttributes.MediaType
                /**
                 * An alias for NA_NUMBER_14_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly ENV_14: java.awt.PageAttributes.MediaType
                /**
                 * An alias for INVITE_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly ENV_INVITE: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ITALY_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly ENV_ITALY: java.awt.PageAttributes.MediaType
                /**
                 * An alias for MONARCH_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly ENV_MONARCH: java.awt.PageAttributes.MediaType
                /**
                 * An alias for PERSONAL_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly ENV_PERSONAL: java.awt.PageAttributes.MediaType
                /**
                 * An alias for INVITE_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly INVITE: java.awt.PageAttributes.MediaType
                /**
                 * An alias for ITALY_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly ITALY: java.awt.PageAttributes.MediaType
                /**
                 * An alias for MONARCH_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly MONARCH: java.awt.PageAttributes.MediaType
                /**
                 * An alias for PERSONAL_ENVELOPE.
                 */
                // @ts-ignore
                public static readonly PERSONAL: java.awt.PageAttributes.MediaType
            }
        }
    }
}
