declare namespace java {
    namespace rmi {
        namespace server {
            /**
             * This exception is thrown when a call is received that does not
             * match the available skeleton.  It indicates either that the
             * remote method names or signatures in this interface have changed or
             * that the stub class used to make the call and the skeleton
             * receiving the call were not generated by the same version of
             * the stub compiler (<code>rmic</code>).
             * @author Roger Riggs
             * @since JDK1.1
             * @deprecated no replacement.  Skeletons are no longer required for remote
             *  method calls in the Java 2 platform v1.2 and greater.
             */
            // @ts-ignore
            class SkeletonMismatchException extends java.rmi.RemoteException {
                /**
                 * Constructs a new <code>SkeletonMismatchException</code> with
                 * a specified detail message.
                 * @param s the detail message
                 * @since JDK1.1
                 * @deprecated no replacement
                 */
                // @ts-ignore
                constructor(s: java.lang.String | string)
            }
        }
    }
}
