declare namespace java {
    namespace security {
        namespace spec {
            /**
             * A (transparent) specification of cryptographic parameters.
             * <P> This interface contains no methods or constants. Its only purpose
             * is to group (and provide type safety for) all parameter specifications.
             * All parameter specifications must implement this interface.
             * @author Jan Luehe
             * @see java.security.AlgorithmParameters
             * @see DSAParameterSpec
             * @since 1.2
             */
            // @ts-ignore
            interface AlgorithmParameterSpec {
            }
        }
    }
}
