declare namespace javax {
    namespace print {
        namespace attribute {
            namespace standard {
                /**
                 * Class MediaSizeName is a subclass of Media.
                 * <P>
                 * This attribute can be used instead of specifying MediaName or MediaTray.
                 * <p>
                 * Class MediaSizeName currently declares a few standard media
                 * name values.
                 * <P>
                 * <B>IPP Compatibility:</B> MediaSizeName is a representation class for
                 * values of the IPP "media" attribute which names media sizes.
                 * The names of the media sizes correspond to those in the IPP 1.1 RFC
                 * <a HREF="http://www.ietf.org/rfc/rfc2911.txt">RFC 2911</a>
                 * <P>
                 */
                // @ts-ignore
                class MediaSizeName extends javax.print.attribute.standard.Media {
                    /**
                     * Construct a new media size enumeration value with the given integer
                     * value.
                     * @param value  Integer value.
                     */
                    // @ts-ignore
                    constructor(value: number /*int*/)
                    /**
                     * A0 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_A0: javax.print.attribute.standard.MediaSizeName
                    /**
                     * A1 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_A1: javax.print.attribute.standard.MediaSizeName
                    /**
                     * A2 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_A2: javax.print.attribute.standard.MediaSizeName
                    /**
                     * A3 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_A3: javax.print.attribute.standard.MediaSizeName
                    /**
                     * A4 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_A4: javax.print.attribute.standard.MediaSizeName
                    /**
                     * A5 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_A5: javax.print.attribute.standard.MediaSizeName
                    /**
                     * A6 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_A6: javax.print.attribute.standard.MediaSizeName
                    /**
                     * A7 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_A7: javax.print.attribute.standard.MediaSizeName
                    /**
                     * A8 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_A8: javax.print.attribute.standard.MediaSizeName
                    /**
                     * A9 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_A9: javax.print.attribute.standard.MediaSizeName
                    /**
                     * A10 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_A10: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ISO B0 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_B0: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ISO B1 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_B1: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ISO B2 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_B2: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ISO B3 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_B3: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ISO B4 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_B4: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ISO B5 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_B5: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ISO B6 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_B6: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ISO B7 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_B7: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ISO B8 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_B8: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ISO B9 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_B9: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ISO B10 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_B10: javax.print.attribute.standard.MediaSizeName
                    /**
                     * JIS B0 size.
                     */
                    // @ts-ignore
                    public static readonly JIS_B0: javax.print.attribute.standard.MediaSizeName
                    /**
                     * JIS B1 size.
                     */
                    // @ts-ignore
                    public static readonly JIS_B1: javax.print.attribute.standard.MediaSizeName
                    /**
                     * JIS B2 size.
                     */
                    // @ts-ignore
                    public static readonly JIS_B2: javax.print.attribute.standard.MediaSizeName
                    /**
                     * JIS B3 size.
                     */
                    // @ts-ignore
                    public static readonly JIS_B3: javax.print.attribute.standard.MediaSizeName
                    /**
                     * JIS B4 size.
                     */
                    // @ts-ignore
                    public static readonly JIS_B4: javax.print.attribute.standard.MediaSizeName
                    /**
                     * JIS B5 size.
                     */
                    // @ts-ignore
                    public static readonly JIS_B5: javax.print.attribute.standard.MediaSizeName
                    /**
                     * JIS B6 size.
                     */
                    // @ts-ignore
                    public static readonly JIS_B6: javax.print.attribute.standard.MediaSizeName
                    /**
                     * JIS B7 size.
                     */
                    // @ts-ignore
                    public static readonly JIS_B7: javax.print.attribute.standard.MediaSizeName
                    /**
                     * JIS B8 size.
                     */
                    // @ts-ignore
                    public static readonly JIS_B8: javax.print.attribute.standard.MediaSizeName
                    /**
                     * JIS B9 size.
                     */
                    // @ts-ignore
                    public static readonly JIS_B9: javax.print.attribute.standard.MediaSizeName
                    /**
                     * JIS B10 size.
                     */
                    // @ts-ignore
                    public static readonly JIS_B10: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ISO C0 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_C0: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ISO C1 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_C1: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ISO C2 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_C2: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ISO C3 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_C3: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ISO C4 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_C4: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ISO C5 size.
                     */
                    // @ts-ignore
                    public static readonly ISO_C5: javax.print.attribute.standard.MediaSizeName
                    /**
                     * letter size.
                     */
                    // @ts-ignore
                    public static readonly ISO_C6: javax.print.attribute.standard.MediaSizeName
                    /**
                     * letter size.
                     */
                    // @ts-ignore
                    public static readonly NA_LETTER: javax.print.attribute.standard.MediaSizeName
                    /**
                     * legal size .
                     */
                    // @ts-ignore
                    public static readonly NA_LEGAL: javax.print.attribute.standard.MediaSizeName
                    /**
                     * executive size .
                     */
                    // @ts-ignore
                    public static readonly EXECUTIVE: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ledger size .
                     */
                    // @ts-ignore
                    public static readonly LEDGER: javax.print.attribute.standard.MediaSizeName
                    /**
                     * tabloid size .
                     */
                    // @ts-ignore
                    public static readonly TABLOID: javax.print.attribute.standard.MediaSizeName
                    /**
                     * invoice size .
                     */
                    // @ts-ignore
                    public static readonly INVOICE: javax.print.attribute.standard.MediaSizeName
                    /**
                     * folio size .
                     */
                    // @ts-ignore
                    public static readonly FOLIO: javax.print.attribute.standard.MediaSizeName
                    /**
                     * quarto size .
                     */
                    // @ts-ignore
                    public static readonly QUARTO: javax.print.attribute.standard.MediaSizeName
                    /**
                     * Japanese Postcard size.
                     */
                    // @ts-ignore
                    public static readonly JAPANESE_POSTCARD: javax.print.attribute.standard.MediaSizeName
                    /**
                     * Japanese Double Postcard size.
                     */
                    // @ts-ignore
                    public static readonly JAPANESE_DOUBLE_POSTCARD: javax.print.attribute.standard.MediaSizeName
                    /**
                     * A size .
                     */
                    // @ts-ignore
                    public static readonly A: javax.print.attribute.standard.MediaSizeName
                    /**
                     * B size .
                     */
                    // @ts-ignore
                    public static readonly B: javax.print.attribute.standard.MediaSizeName
                    /**
                     * C size .
                     */
                    // @ts-ignore
                    public static readonly C: javax.print.attribute.standard.MediaSizeName
                    /**
                     * D size .
                     */
                    // @ts-ignore
                    public static readonly D: javax.print.attribute.standard.MediaSizeName
                    /**
                     * E size .
                     */
                    // @ts-ignore
                    public static readonly E: javax.print.attribute.standard.MediaSizeName
                    /**
                     * ISO designated long size .
                     */
                    // @ts-ignore
                    public static readonly ISO_DESIGNATED_LONG: javax.print.attribute.standard.MediaSizeName
                    /**
                     * Italy envelope size .
                     */
                    // @ts-ignore
                    public static readonly ITALY_ENVELOPE: javax.print.attribute.standard.MediaSizeName
                    /**
                     * monarch envelope size .
                     */
                    // @ts-ignore
                    public static readonly MONARCH_ENVELOPE: javax.print.attribute.standard.MediaSizeName
                    /**
                     * personal envelope size .
                     */
                    // @ts-ignore
                    public static readonly PERSONAL_ENVELOPE: javax.print.attribute.standard.MediaSizeName
                    /**
                     * number 9 envelope size .
                     */
                    // @ts-ignore
                    public static readonly NA_NUMBER_9_ENVELOPE: javax.print.attribute.standard.MediaSizeName
                    /**
                     * number 10 envelope size .
                     */
                    // @ts-ignore
                    public static readonly NA_NUMBER_10_ENVELOPE: javax.print.attribute.standard.MediaSizeName
                    /**
                     * number 11 envelope size .
                     */
                    // @ts-ignore
                    public static readonly NA_NUMBER_11_ENVELOPE: javax.print.attribute.standard.MediaSizeName
                    /**
                     * number 12 envelope size .
                     */
                    // @ts-ignore
                    public static readonly NA_NUMBER_12_ENVELOPE: javax.print.attribute.standard.MediaSizeName
                    /**
                     * number 14 envelope size .
                     */
                    // @ts-ignore
                    public static readonly NA_NUMBER_14_ENVELOPE: javax.print.attribute.standard.MediaSizeName
                    /**
                     * 6x9 North American envelope size.
                     */
                    // @ts-ignore
                    public static readonly NA_6X9_ENVELOPE: javax.print.attribute.standard.MediaSizeName
                    /**
                     * 7x9 North American envelope size.
                     */
                    // @ts-ignore
                    public static readonly NA_7X9_ENVELOPE: javax.print.attribute.standard.MediaSizeName
                    /**
                     * 9x11 North American envelope size.
                     */
                    // @ts-ignore
                    public static readonly NA_9X11_ENVELOPE: javax.print.attribute.standard.MediaSizeName
                    /**
                     * 9x12 North American envelope size.
                     */
                    // @ts-ignore
                    public static readonly NA_9X12_ENVELOPE: javax.print.attribute.standard.MediaSizeName
                    /**
                     * 10x13 North American envelope size .
                     */
                    // @ts-ignore
                    public static readonly NA_10X13_ENVELOPE: javax.print.attribute.standard.MediaSizeName
                    /**
                     * 10x14North American  envelope size .
                     */
                    // @ts-ignore
                    public static readonly NA_10X14_ENVELOPE: javax.print.attribute.standard.MediaSizeName
                    /**
                     * 10x15 North American envelope size.
                     */
                    // @ts-ignore
                    public static readonly NA_10X15_ENVELOPE: javax.print.attribute.standard.MediaSizeName
                    /**
                     * 5x7 North American paper.
                     */
                    // @ts-ignore
                    public static readonly NA_5X7: javax.print.attribute.standard.MediaSizeName
                    /**
                     * 8x10 North American paper.
                     */
                    // @ts-ignore
                    public static readonly NA_8X10: javax.print.attribute.standard.MediaSizeName
                    /**
                     * Returns the string table for class MediaSizeName.
                     */
                    // @ts-ignore
                    getStringTable(): string[]
                    /**
                     * Returns the enumeration value table for class MediaSizeName.
                     */
                    // @ts-ignore
                    getEnumValueTable(): javax.print.attribute.EnumSyntax[]
                }
            }
        }
    }
}
