declare namespace javax {
    namespace print {
        namespace attribute {
            namespace standard {
                /**
                 * Class PagesPerMinute is an integer valued printing attribute that indicates
                 * the nominal number of pages per minute to the nearest whole number which may
                 * be generated by this printer (e.g., simplex, black-and-white). This attribute
                 * is informative, not a service guarantee. Generally, it is the value used in
                 * the marketing literature to describe the device. A value of 0 indicates a
                 * device that takes more than two minutes to process a page.
                 * <P>
                 * <B>IPP Compatibility:</B> The integer value gives the IPP integer value. The
                 * category name returned by <CODE>getName()</CODE> gives the IPP attribute
                 * name.
                 * <P>
                 * @author Alan Kaminsky
                 */
                // @ts-ignore
                class PagesPerMinute extends javax.print.attribute.IntegerSyntax implements javax.print.attribute.PrintServiceAttribute {
                    /**
                     * Construct a new pages per minute attribute with the given integer
                     * value.
                     * @param value  Integer value.
                     * @exception IllegalArgumentException
                     *    (Unchecked exception) Thrown if <CODE>value</CODE> is less than 0.
                     */
                    // @ts-ignore
                    constructor(value: number /*int*/)
                    /**
                     * Returns whether this pages per minute attribute is equivalent to the
                     * passed in object. To be equivalent, all of the following conditions
                     * must be true:
                     * <OL TYPE=1>
                     * <LI>
                     * <CODE>object</CODE> is not null.
                     * <LI>
                     * <CODE>object</CODE> is an instance of class PagesPerMinute.
                     * <LI>
                     * This pages per minute attribute's value and <CODE>object</CODE>'s
                     * value are equal.
                     * </OL>
                     * @param object  Object to compare to.
                     * @return True if <CODE>object</CODE> is equivalent to this pages per
                     *           minute attribute, false otherwise.
                     */
                    // @ts-ignore
                    public equals(object: java.lang.Object | any): boolean
                    /**
                     * Get the printing attribute class which is to be used as the "category"
                     * for this printing attribute value.
                     * <P>
                     * For class PagesPerMinute, the category is class PagesPerMinute itself.
                     * @return Printing attribute class (category), an instance of class
                     *           {#link java.lang.Class java.lang.Class}.
                     */
                    // @ts-ignore
                    public getCategory(): java.lang.Class<any>
                    /**
                     * Get the name of the category of which this attribute value is an
                     * instance.
                     * <P>
                     * For class PagesPerMinute, the
                     * category name is <CODE>"pages-per-minute"</CODE>.
                     * @return Attribute category name.
                     */
                    // @ts-ignore
                    public getName(): string
                }
            }
        }
    }
}
