declare namespace javax {
    namespace swing {
        /**
         * Constants used with the JScrollPane component.
         * @author Hans Muller
         */
        // @ts-ignore
        interface ScrollPaneConstants {
            /**
             * Identifies a "viewport" or display area, within which
             * scrolled contents are visible.
             */
            // @ts-ignore
            readonly VIEWPORT: java.lang.String | string
            /**
             * Identifies a vertical scrollbar.
             */
            // @ts-ignore
            readonly VERTICAL_SCROLLBAR: java.lang.String | string
            /**
             * Identifies a horizontal scrollbar.
             */
            // @ts-ignore
            readonly HORIZONTAL_SCROLLBAR: java.lang.String | string
            /**
             * Identifies the area along the left side of the viewport between the
             * upper left corner and the lower left corner.
             */
            // @ts-ignore
            readonly ROW_HEADER: java.lang.String | string
            /**
             * Identifies the area at the top the viewport between the
             * upper left corner and the upper right corner.
             */
            // @ts-ignore
            readonly COLUMN_HEADER: java.lang.String | string
            /**
             * Identifies the lower left corner of the viewport.
             */
            // @ts-ignore
            readonly LOWER_LEFT_CORNER: java.lang.String | string
            /**
             * Identifies the lower right corner of the viewport.
             */
            // @ts-ignore
            readonly LOWER_RIGHT_CORNER: java.lang.String | string
            /**
             * Identifies the upper left corner of the viewport.
             */
            // @ts-ignore
            readonly UPPER_LEFT_CORNER: java.lang.String | string
            /**
             * Identifies the upper right corner of the viewport.
             */
            // @ts-ignore
            readonly UPPER_RIGHT_CORNER: java.lang.String | string
            /**
             * Identifies the lower leading edge corner of the viewport. The leading edge
             * is determined relative to the Scroll Pane's ComponentOrientation property.
             */
            // @ts-ignore
            readonly LOWER_LEADING_CORNER: java.lang.String | string
            /**
             * Identifies the lower trailing edge corner of the viewport. The trailing edge
             * is determined relative to the Scroll Pane's ComponentOrientation property.
             */
            // @ts-ignore
            readonly LOWER_TRAILING_CORNER: java.lang.String | string
            /**
             * Identifies the upper leading edge corner of the viewport.  The leading edge
             * is determined relative to the Scroll Pane's ComponentOrientation property.
             */
            // @ts-ignore
            readonly UPPER_LEADING_CORNER: java.lang.String | string
            /**
             * Identifies the upper trailing edge corner of the viewport. The trailing edge
             * is determined relative to the Scroll Pane's ComponentOrientation property.
             */
            // @ts-ignore
            readonly UPPER_TRAILING_CORNER: java.lang.String | string
            /**
             * Identifies the vertical scroll bar policy property.
             */
            // @ts-ignore
            readonly VERTICAL_SCROLLBAR_POLICY: java.lang.String | string
            /**
             * Identifies the horizontal scroll bar policy property.
             */
            // @ts-ignore
            readonly HORIZONTAL_SCROLLBAR_POLICY: java.lang.String | string
            /**
             * Used to set the vertical scroll bar policy so that
             * vertical scrollbars are displayed only when needed.
             */
            // @ts-ignore
            readonly VERTICAL_SCROLLBAR_AS_NEEDED: number /*int*/
            /**
             * Used to set the vertical scroll bar policy so that
             * vertical scrollbars are never displayed.
             */
            // @ts-ignore
            readonly VERTICAL_SCROLLBAR_NEVER: number /*int*/
            /**
             * Used to set the vertical scroll bar policy so that
             * vertical scrollbars are always displayed.
             */
            // @ts-ignore
            readonly VERTICAL_SCROLLBAR_ALWAYS: number /*int*/
            /**
             * Used to set the horizontal scroll bar policy so that
             * horizontal scrollbars are displayed only when needed.
             */
            // @ts-ignore
            readonly HORIZONTAL_SCROLLBAR_AS_NEEDED: number /*int*/
            /**
             * Used to set the horizontal scroll bar policy so that
             * horizontal scrollbars are never displayed.
             */
            // @ts-ignore
            readonly HORIZONTAL_SCROLLBAR_NEVER: number /*int*/
            /**
             * Used to set the horizontal scroll bar policy so that
             * horizontal scrollbars are always displayed.
             */
            // @ts-ignore
            readonly HORIZONTAL_SCROLLBAR_ALWAYS: number /*int*/
        }
    }
}
