declare namespace javax {
    namespace swing {
        /**
         * A collection of constants generally used for positioning and orienting
         * components on the screen.
         * @author Jeff Dinkins
         * @author Ralph Kar (orientation support)
         */
        // @ts-ignore
        interface SwingConstants {
            /**
             * The central position in an area. Used for
             * both compass-direction constants (NORTH, etc.)
             * and box-orientation constants (TOP, etc.).
             */
            // @ts-ignore
            readonly CENTER: number /*int*/
            /**
             * Box-orientation constant used to specify the top of a box.
             */
            // @ts-ignore
            readonly TOP: number /*int*/
            /**
             * Box-orientation constant used to specify the left side of a box.
             */
            // @ts-ignore
            readonly LEFT: number /*int*/
            /**
             * Box-orientation constant used to specify the bottom of a box.
             */
            // @ts-ignore
            readonly BOTTOM: number /*int*/
            /**
             * Box-orientation constant used to specify the right side of a box.
             */
            // @ts-ignore
            readonly RIGHT: number /*int*/
            /**
             * Compass-direction North (up).
             */
            // @ts-ignore
            readonly NORTH: number /*int*/
            /**
             * Compass-direction north-east (upper right).
             */
            // @ts-ignore
            readonly NORTH_EAST: number /*int*/
            /**
             * Compass-direction east (right).
             */
            // @ts-ignore
            readonly EAST: number /*int*/
            /**
             * Compass-direction south-east (lower right).
             */
            // @ts-ignore
            readonly SOUTH_EAST: number /*int*/
            /**
             * Compass-direction south (down).
             */
            // @ts-ignore
            readonly SOUTH: number /*int*/
            /**
             * Compass-direction south-west (lower left).
             */
            // @ts-ignore
            readonly SOUTH_WEST: number /*int*/
            /**
             * Compass-direction west (left).
             */
            // @ts-ignore
            readonly WEST: number /*int*/
            /**
             * Compass-direction north west (upper left).
             */
            // @ts-ignore
            readonly NORTH_WEST: number /*int*/
            /**
             * Horizontal orientation. Used for scrollbars and sliders.
             */
            // @ts-ignore
            readonly HORIZONTAL: number /*int*/
            /**
             * Vertical orientation. Used for scrollbars and sliders.
             */
            // @ts-ignore
            readonly VERTICAL: number /*int*/
            /**
             * Identifies the leading edge of text for use with left-to-right
             * and right-to-left languages. Used by buttons and labels.
             */
            // @ts-ignore
            readonly LEADING: number /*int*/
            /**
             * Identifies the trailing edge of text for use with left-to-right
             * and right-to-left languages. Used by buttons and labels.
             */
            // @ts-ignore
            readonly TRAILING: number /*int*/
            /**
             * Identifies the next direction in a sequence.
             * @since 1.4
             */
            // @ts-ignore
            readonly NEXT: number /*int*/
            /**
             * Identifies the previous direction in a sequence.
             * @since 1.4
             */
            // @ts-ignore
            readonly PREVIOUS: number /*int*/
        }
    }
}
