declare namespace javax {
    namespace xml {
        namespace xpath {
            /**
             * <p>XPath constants.</p>
             * @author <a href="mailto:Norman.Walsh#Sun.COM">Norman Walsh</a>
             * @author <a href="mailto:Jeff.Suttor#Sun.COM">Jeff Suttor</a>
             * @see <a href="http://www.w3.org/TR/xpath">XML Path Language (XPath) Version 1.0</a>
             * @since 1.5
             */
            // @ts-ignore
            class XPathConstants extends java.lang.Object {
                /**
                 * <p>The XPath 1.0 number data type.</p>
                 * <p>Maps to Java {@link Double}.</p>
                 */
                // @ts-ignore
                public static readonly NUMBER: javax.xml.namespace.QName
                /**
                 * <p>The XPath 1.0 string data type.</p>
                 * <p>Maps to Java {@link String}.</p>
                 */
                // @ts-ignore
                public static readonly STRING: javax.xml.namespace.QName
                /**
                 * <p>The XPath 1.0 boolean data type.</p>
                 * <p>Maps to Java {@link Boolean}.</p>
                 */
                // @ts-ignore
                public static readonly BOOLEAN: javax.xml.namespace.QName
                /**
                 * <p>The XPath 1.0 NodeSet data type.</p>
                 * <p>Maps to Java {@link org.w3c.dom.NodeList}.</p>
                 */
                // @ts-ignore
                public static readonly NODESET: javax.xml.namespace.QName
                /**
                 * <p>The XPath 1.0 NodeSet data type.
                 * <p>Maps to Java {@link org.w3c.dom.Node}.</p>
                 */
                // @ts-ignore
                public static readonly NODE: javax.xml.namespace.QName
                /**
                 * <p>The URI for the DOM object model, "http://java.sun.com/jaxp/xpath/dom".</p>
                 */
                // @ts-ignore
                public static readonly DOM_OBJECT_MODEL: java.lang.String | string
            }
        }
    }
}
